diff -ruN vdr-1.3.37/recording.h vdr-1.3.38/recording.h
--- vdr-1.3.37/recording.h	2005-10-31 13:27:12.000000000 +0100
+++ vdr-1.3.38/recording.h	2005-12-18 12:26:51.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.h 1.46 2005/10/31 12:27:12 kls Exp $
+ * $Id: recording.h 1.48 2005/12/18 11:26:51 kls Exp $
  */
 
 #ifndef __RECORDING_H
@@ -55,12 +55,14 @@
   };
 
 class cRecording : public cListObject {
+  friend class cRecordings;
 private:
   mutable int resume;
   mutable char *titleBuffer;
   mutable char *sortBuffer;
   mutable char *fileName;
   mutable char *name;
+  mutable int fileSizeMB;
   cRecordingInfo *info;
   static char *StripEpisodeName(char *s);
   char *SortName(void) const;
@@ -69,6 +71,7 @@
   time_t start;
   int priority;
   int lifetime;
+  time_t deleted;
   cRecording(cTimer *Timer, const cEvent *Event);
   cRecording(const char *FileName);
   virtual ~cRecording();
@@ -126,9 +129,11 @@
   cRecording *GetByName(const char *FileName);
   void AddByName(const char *FileName);
   void DelByName(const char *FileName);
+  int TotalFileSizeMB(void); ///< Only for deleted recordings!
   };
 
 extern cRecordings Recordings;
+extern cRecordings DeletedRecordings;
 
 class cMark : public cListObject {
 public:
diff -ruN vdr-1.3.37/remote.c vdr-1.3.38/remote.c
--- vdr-1.3.37/remote.c	2005-09-03 14:29:48.000000000 +0200
+++ vdr-1.3.38/remote.c	2006-01-01 15:21:07.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.c 1.45 2005/09/03 12:29:48 kls Exp $
+ * $Id: remote.c 1.46 2006/01/01 14:21:07 kls Exp $
  */
 
 #include "remote.h"
@@ -262,43 +262,72 @@
   return (Code <= 0xFF) ? Code : kfNone;
 }
 
-void cKbdRemote::Action(void)
+int cKbdRemote::ReadKey(void)
 {
   cPoller Poller(STDIN_FILENO);
+  if (Poller.Poll(50)) {
+     uchar ch = 0;
+     int r = safe_read(STDIN_FILENO, &ch, 1);
+     if (r == 1)
+        return ch;
+     if (r < 0)
+        LOG_ERROR_STR("cKbdRemote");
+     }
+  return -1;
+}
+
+uint64 cKbdRemote::ReadKeySequence(void)
+{
+  uint64 k = 0;
+  int key1;
+
+  if ((key1 = ReadKey()) >= 0) {
+     k = key1;
+     if (key1 == 0x1B) {
+         // Start of escape sequence
+         if ((key1 = ReadKey()) >= 0) {
+            k <<= 8;
+            k |= key1 & 0xFF;
+            switch (key1) {
+              case 0x4F: // 3-byte sequence
+                   if ((key1 = ReadKey()) >= 0) {
+                      k <<= 8;
+                      k |= key1 & 0xFF;
+                      }
+                   break;
+              case 0x5B: // 3- or more-byte sequence
+                   if ((key1 = ReadKey()) >= 0) {
+                      k <<= 8;
+                      k |= key1 & 0xFF;
+                      switch (key1) {
+                        case 0x31 ... 0x3F: // more-byte sequence
+                             while (key1 != 0x7E) {
+                                   k <<= 8;
+                                   k |= key1 & 0xFF;
+                                   if ((key1 = ReadKey()) < 0)
+                                      break; // Sequence ends here
+                                   }
+                             break;
+                        }
+                      }
+                   break;
+              }
+            }
+        }
+     }
+  return k;
+}
+
+void cKbdRemote::Action(void)
+{
   while (Running()) {
-        if (Poller.Poll(100)) {
-           uint64 Command = 0;
-           uint i = 0;
-           while (Running() && i < sizeof(Command)) {
-                 uchar ch;
-                 int r = read(STDIN_FILENO, &ch, 1);
-                 if (r == 1) {
-                    Command <<= 8;
-                    Command |= ch;
-                    i++;
-                    }
-                 else if (r == 0) {
-                    // don't know why, but sometimes special keys that start with
-                    // 0x1B ('ESC') cause a short gap between the 0x1B and the rest
-                    // of their codes, so we'll need to wait some 100ms to see if
-                    // there is more coming up - or whether this really is the 'ESC'
-                    // key (if somebody knows how to clean this up, please let me know):
-                    if (Command == 0x1B && Poller.Poll(100))
-                       continue;
-                    if (Command) {
-                       if (rawMode || !Put(Command)) {
-                          int func = MapCodeToFunc(Command);
-                          if (func)
-                             Put(KBDKEY(func));
-                          }
-                       }
-                    break;
-                    }
-                 else {
-                    LOG_ERROR;
-                    break;
-                    }
-                 }
+        uint64 Command = ReadKeySequence();
+        if (Command) {
+           if (rawMode || !Put(Command)) {
+              int func = MapCodeToFunc(Command);
+              if (func)
+                 Put(KBDKEY(func));
+              }
            }
         }
 }
diff -ruN vdr-1.3.37/remote.h vdr-1.3.38/remote.h
--- vdr-1.3.37/remote.h	2005-09-03 14:28:42.000000000 +0200
+++ vdr-1.3.38/remote.h	2006-01-01 15:00:50.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.h 1.31 2005/09/03 12:28:42 kls Exp $
+ * $Id: remote.h 1.32 2006/01/01 14:00:50 kls Exp $
  */
 
 #ifndef __REMOTE_H
@@ -89,6 +89,8 @@
   static bool rawMode;
   struct termios savedTm;
   virtual void Action(void);
+  int ReadKey(void);
+  uint64 ReadKeySequence(void);
   int MapCodeToFunc(uint64 Code);
 public:
   cKbdRemote(void);
diff -ruN vdr-1.3.37/remux.c vdr-1.3.38/remux.c
--- vdr-1.3.37/remux.c	2005-09-11 15:26:50.000000000 +0200
+++ vdr-1.3.38/remux.c	2006-01-08 12:40:16.000000000 +0100
@@ -11,7 +11,7 @@
  * The cRepacker family's code was originally written by Reinhard Nissl <rnissl@gmx.de>,
  * and adapted to the VDR coding style by Klaus.Schmidinger@cadsoft.de.
  *
- * $Id: remux.c 1.47 2005/09/11 13:26:50 kls Exp $
+ * $Id: remux.c 1.53 2006/01/08 11:40:16 kls Exp $
  */
 
 #include "remux.h"
@@ -88,15 +88,21 @@
 
 // --- cRepacker -------------------------------------------------------------
 
+#define MIN_LOG_INTERVAL 10 // min. # of seconds between two consecutive log messages of a cRepacker
+#define LOG(a...) (LogAllowed() && (esyslog(a), true))
+
 class cRepacker {
 protected:
   bool initiallySyncing;
   int maxPacketSize;
   uint8_t subStreamId;
-  static void DroppedData(const char *Reason, int Count) { esyslog("%s (dropped %d bytes)", Reason, Count); }
+  time_t lastLog;
+  int suppressedLogMessages;
+  bool LogAllowed(void);
+  void DroppedData(const char *Reason, int Count) { LOG("%s (dropped %d bytes)", Reason, Count); }
 public:
   static int Put(cRingBufferLinear *ResultBuffer, const uchar *Data, int Count, int CapacityNeeded);
-  cRepacker(void) { initiallySyncing = true; maxPacketSize = 6 + 65535; subStreamId = 0; }
+  cRepacker(void);
   virtual ~cRepacker() {}
   virtual void Reset(void) { initiallySyncing = true; }
   virtual void Repack(cRingBufferLinear *ResultBuffer, const uchar *Data, int Count) = 0;
@@ -106,6 +112,30 @@
   void SetSubStreamId(uint8_t SubStreamId) { subStreamId = SubStreamId; }
   };
 
+cRepacker::cRepacker(void)
+{
+  initiallySyncing = true;
+  maxPacketSize = 6 + 65535;
+  subStreamId = 0;
+  suppressedLogMessages = 0;;
+  lastLog = 0;
+}
+
+bool cRepacker::LogAllowed(void)
+{
+  bool Allowed = time(NULL) - lastLog >= MIN_LOG_INTERVAL;
+  lastLog = time(NULL);
+  if (Allowed) {
+     if (suppressedLogMessages) {
+        esyslog("%d cRepacker messages suppressed", suppressedLogMessages);
+        suppressedLogMessages = 0;
+        }
+     }
+  else
+     suppressedLogMessages++;
+  return Allowed;
+}
+
 int cRepacker::Put(cRingBufferLinear *ResultBuffer, const uchar *Data, int Count, int CapacityNeeded)
 {
   if (CapacityNeeded >= Count && ResultBuffer->Free() < CapacityNeeded) {
@@ -160,7 +190,7 @@
      // just skip packets with no payload
      int PesPayloadOffset = 0;
      if (AnalyzePesHeader(fragmentData, fragmentLen, PesPayloadOffset) <= phInvalid)
-        esyslog("cCommonRepacker: invalid PES packet encountered in fragment buffer!");
+        LOG("cCommonRepacker: invalid PES packet encountered in fragment buffer!");
      else if (6 + PacketLen <= PesPayloadOffset) {
         fragmentLen = 0;
         return true; // skip empty packet
@@ -181,7 +211,7 @@
      // just skip packets with no payload
      int PesPayloadOffset = 0;
      if (AnalyzePesHeader(pesHeader, pesHeaderLen, PesPayloadOffset) <= phInvalid)
-        esyslog("cCommonRepacker: invalid PES packet encountered in header buffer!");
+        LOG("cCommonRepacker: invalid PES packet encountered in header buffer!");
      else if (6 + PacketLen <= PesPayloadOffset) {
         pesHeaderLen = 0;
         return true; // skip empty packet
@@ -216,7 +246,8 @@
     syncing,
     findPicture,
     scanPicture
-    } state;
+    };
+  int state;
 public:
   cVideoRepacker(void);
   virtual void Reset(void);
@@ -278,14 +309,14 @@
            // which kind of start code have we got?
            switch (*data) {
              case 0xB9 ... 0xFF: // system start codes
-                  esyslog("cVideoRepacker: found system start code: stream seems to be scrambled or not demultiplexed");
+                  LOG("cVideoRepacker: found system start code: stream seems to be scrambled or not demultiplexed");
                   break;
              case 0xB0 ... 0xB1: // reserved start codes
              case 0xB6:
-                  esyslog("cVideoRepacker: found reserved start code: stream seems to be scrambled");
+                  LOG("cVideoRepacker: found reserved start code: stream seems to be scrambled");
                   break;
              case 0xB4: // sequence error code
-                  isyslog("cVideoRepacker: found sequence error code: stream seems to be damaged");
+                  LOG("cVideoRepacker: found sequence error code: stream seems to be damaged");
              case 0xB2: // user data start code
              case 0xB5: // extension start code
                   break;
@@ -307,7 +338,7 @@
                      if (initiallySyncing) // omit report for the typical initial case
                         initiallySyncing = false;
                      else if (skippedBytes > SkippedBytesLimit) // report that syncing dropped some bytes
-                        esyslog("cVideoRepacker: skipped %d bytes to sync on next picture", skippedBytes - SkippedBytesLimit);
+                        LOG("cVideoRepacker: skipped %d bytes to sync on next picture", skippedBytes - SkippedBytesLimit);
                      skippedBytes = 0;
                      // if there is a PES header available, then use it ...
                      if (pesHeaderBackupLen > 0) {
@@ -350,13 +381,13 @@
                      // maximum we can hold in one PES packet
                      packetTodo = maxPacketSize - pesHeaderLen;
                      // go on with finding the picture data
-                     ((int &)state)++;
+                     state++;
                      }
                   break;
              case 0x01 ... 0xAF: // slice start codes
                   if (state == findPicture) {
                      // go on with scanning the picture data
-                     ((int &)state)++;
+                     state++;
                      }
                   break;
              }
@@ -465,7 +496,7 @@
   // report that syncing dropped some bytes
   if (skippedBytes > SkippedBytesLimit) {
      if (!initiallySyncing) // omit report for the typical initial case
-        esyslog("cVideoRepacker: skipped %d bytes while syncing on next picture", skippedBytes - SkippedBytesLimit);
+        LOG("cVideoRepacker: skipped %d bytes while syncing on next picture", skippedBytes - SkippedBytesLimit);
      skippedBytes = SkippedBytesLimit;
      }
 }
@@ -517,7 +548,8 @@
   enum eState {
     syncing,
     scanFrame
-    } state;
+    };
+  int state;
   int frameTodo;
   int frameSize;
   int cid;
@@ -674,7 +706,7 @@
                  if (initiallySyncing) // omit report for the typical initial case
                     initiallySyncing = false;
                  else if (skippedBytes > SkippedBytesLimit) // report that syncing dropped some bytes
-                    esyslog("cAudioRepacker(0x%02X): skipped %d bytes to sync on next audio frame", cid, skippedBytes - SkippedBytesLimit);
+                    LOG("cAudioRepacker(0x%02X): skipped %d bytes to sync on next audio frame", cid, skippedBytes - SkippedBytesLimit);
                  skippedBytes = 0;
                  // if there is a PES header available, then use it ...
                  if (pesHeaderBackupLen > 0) {
@@ -714,10 +746,10 @@
                  payload = data;
                  // maximum we can hold in one PES packet
                  packetTodo = maxPacketSize - pesHeaderLen;
-                 // expected remainder of audio frame: so far we have read 3 bytes from the frame header 
+                 // expected remainder of audio frame: so far we have read 3 bytes from the frame header
                  frameTodo = frameSize - 3;
                  // go on with collecting the frame's data
-                 ((int &)state)++;
+                 state++;
                  }
               }
            }
@@ -832,7 +864,7 @@
   // report that syncing dropped some bytes
   if (skippedBytes > SkippedBytesLimit) {
      if (!initiallySyncing) // omit report for the typical initial case
-        esyslog("cAudioRepacker(0x%02X): skipped %d bytes while syncing on next audio frame", cid, skippedBytes - SkippedBytesLimit);
+        LOG("cAudioRepacker(0x%02X): skipped %d bytes while syncing on next audio frame", cid, skippedBytes - SkippedBytesLimit);
      skippedBytes = SkippedBytesLimit;
      }
 }
@@ -898,14 +930,15 @@
   uchar chk1;
   uchar chk2;
   int ac3todo;
-  enum {
+  enum eState {
     find_0b,
     find_77,
     store_chk1,
     store_chk2,
     get_length,
     output_packet
-    } state;
+    };
+  int state;
   int skippedBytes;
   void ResetPesHeader(bool ContinuationFrame = false);
   void AppendSubStreamID(bool ContinuationFrame = false);
@@ -1090,7 +1123,7 @@
         switch (state) {
           case find_0b:
                if (*data == 0x0B) {
-                  ++(int &)state;
+                  state++;
                   // copy header information once for later use
                   if (pesHeaderBackupLen > 0) {
                      pesHeaderLen = pesHeaderBackupLen;
@@ -1113,21 +1146,21 @@
                done++;
                todo--;
                skippedBytes++; // collect number of skipped bytes while syncing
-               ++(int &)state;
+               state++;
                continue;
           case store_chk1:
                chk1 = *data++;
                done++;
                todo--;
                skippedBytes++; // collect number of skipped bytes while syncing
-               ++(int &)state;
+               state++;
                continue;
           case store_chk2:
                chk2 = *data++;
                done++;
                todo--;
                skippedBytes++; // collect number of skipped bytes while syncing
-               ++(int &)state;
+               state++;
                continue;
           case get_length:
                ac3todo = 2 * frameSizes[*data];
@@ -1157,7 +1190,7 @@
                if (initiallySyncing) // omit report for the typical initial case
                   initiallySyncing = false;
                else if (skippedBytes > SkippedBytesLimit) // report that syncing dropped some bytes
-                  esyslog("cDolbyRepacker: skipped %d bytes to sync on next AC3 frame", skippedBytes - SkippedBytesLimit);
+                  LOG("cDolbyRepacker: skipped %d bytes to sync on next AC3 frame", skippedBytes - SkippedBytesLimit);
                skippedBytes = 0;
                // append read data to header for common output processing
                pesHeader[pesHeaderLen++] = 0x0B;
@@ -1165,7 +1198,7 @@
                pesHeader[pesHeaderLen++] = chk1;
                pesHeader[pesHeaderLen++] = chk2;
                ac3todo -= 4;
-               ++(int &)state;
+               state++;
                // fall through to output
           case output_packet: {
                int bite = 0;
@@ -1188,7 +1221,7 @@
   // report that syncing dropped some bytes
   if (skippedBytes > SkippedBytesLimit) {
      if (!initiallySyncing) // omit report for the typical initial case
-        esyslog("cDolbyRepacker: skipped %d bytes while syncing on next AC3 frame", skippedBytes - 4);
+        LOG("cDolbyRepacker: skipped %d bytes while syncing on next AC3 frame", skippedBytes - 4);
      skippedBytes = SkippedBytesLimit;
      }
 }
@@ -1248,9 +1281,10 @@
 #define CONT_CNT_MASK  0x0F
 
 // Flags:
+#define PAY_LOAD       0x10
+#define ADAPT_FIELD    0x20
 #define PAY_START      0x40
 #define TS_ERROR       0x80
-#define ADAPT_FIELD    0x20
 
 #define MAX_PLENGTH  0xFFFF          // the maximum PES packet length (theoretically)
 #define MMAX_PLENGTH (64*MAX_PLENGTH) // some stations send PES packets that are extremely large, e.g. DVB-T in Finland or HDTV 1920x1080
@@ -1635,7 +1669,11 @@
 
   if (Buf[1] & TS_ERROR)
      tsErrors++;
-  if ((Buf[3] ^ ccCounter) & CONT_CNT_MASK) {
+
+  if (!(Buf[3] & (ADAPT_FIELD | PAY_LOAD)))
+     return; // discard TS packet with adaption_field_control set to '00'.
+
+  if ((Buf[3] & PAY_LOAD) && ((Buf[3] ^ ccCounter) & CONT_CNT_MASK)) {
      // This should check duplicates and packets which do not increase the counter.
      // But as the errors usually come in bursts this should be enough to
      // show you there is something wrong with signal quality.
@@ -1650,12 +1688,14 @@
      }
 
   if (Buf[1] & PAY_START) {
-     if (plength == MMAX_PLENGTH - 6 && found > 6) {
+     if (found > 6) {
+        if (plength != MMAX_PLENGTH - 6 && plength != found - 6)
+           dsyslog("PES packet shortened to %d bytes (expected: %d bytes)", found, plength + 6);
         plength = found - 6;
-        found = 0;
         send_ipack();
         reset_ipack();
         }
+     found = 0;
      }
 
   uint8_t off = 0;
@@ -1666,7 +1706,8 @@
         return;
      }
 
-  instant_repack(Buf + 4 + off, TS_SIZE - 4 - off);
+  if (Buf[3] & PAY_LOAD)
+     instant_repack(Buf + 4 + off, TS_SIZE - 4 - off);
 }
 
 // --- cRemux ----------------------------------------------------------------
diff -ruN vdr-1.3.37/ringbuffer.c vdr-1.3.38/ringbuffer.c
--- vdr-1.3.37/ringbuffer.c	2004-10-15 15:49:25.000000000 +0200
+++ vdr-1.3.38/ringbuffer.c	2005-12-30 16:42:08.000000000 +0100
@@ -7,7 +7,7 @@
  * Parts of this file were inspired by the 'ringbuffy.c' from the
  * LinuxDVB driver (see linuxtv.org).
  *
- * $Id: ringbuffer.c 1.21 2004/10/15 13:49:25 kls Exp $
+ * $Id: ringbuffer.c 1.23 2005/12/30 15:42:08 kls Exp $
  */
 
 #include "ringbuffer.h"
@@ -46,7 +46,7 @@
   int percent = Fill * 100 / (Size() - 1) / PERCENTAGEDELTA * PERCENTAGEDELTA;
   if (percent != lastPercent) {
      if (percent >= PERCENTAGETHRESHOLD && percent > lastPercent || percent < PERCENTAGETHRESHOLD && lastPercent >= PERCENTAGETHRESHOLD) {
-        dsyslog("buffer usage: %d%% (tid=%ld)", percent, getThreadTid);
+        dsyslog("buffer usage: %d%% (tid=%d)", percent, getThreadTid);
         lastPercent = percent;
         }
      }
@@ -165,10 +165,10 @@
         Clear();
         }
      else
-        esyslog("ERROR: illegal margin for ring buffer (%d > %d)", Margin, Size / 2);
+        esyslog("ERROR: invalid margin for ring buffer (%d > %d)", Margin, Size / 2);
      }
   else
-     esyslog("ERROR: illegal size for ring buffer (%d)", Size);
+     esyslog("ERROR: invalid size for ring buffer (%d)", Size);
 #ifdef DEBUGRINGBUFFERS
   lastHead = head;
   lastTail = tail;
@@ -286,7 +286,7 @@
   uchar *p = NULL;
   int Head = head;
   if (getThreadTid <= 0)
-     getThreadTid = pthread_self();
+     getThreadTid = cThread::ThreadId();
   int rest = Size() - tail;
   if (rest < margin && Head < tail) {
      int t = margin - rest;
diff -ruN vdr-1.3.37/ringbuffer.h vdr-1.3.38/ringbuffer.h
--- vdr-1.3.37/ringbuffer.h	2004-10-15 15:50:46.000000000 +0200
+++ vdr-1.3.38/ringbuffer.h	2005-12-10 11:54:51.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: ringbuffer.h 1.16 2004/10/15 13:50:46 kls Exp $
+ * $Id: ringbuffer.h 1.17 2005/12/10 10:54:51 kls Exp $
  */
 
 #ifndef __RINGBUFFER_H
@@ -23,7 +23,7 @@
   int overflowCount;
   int overflowBytes;
 protected:
-  pthread_t getThreadTid;
+  tThreadId getThreadTid;
   int maxFill;//XXX
   int lastPercent;
   bool statistics;//XXX
diff -ruN vdr-1.3.37/runvdr vdr-1.3.38/runvdr
--- vdr-1.3.37/runvdr	2004-11-21 12:30:00.000000000 +0100
+++ vdr-1.3.38/runvdr	2005-12-31 17:04:53.000000000 +0100
@@ -7,7 +7,7 @@
 #
 # Set the environment variable VDRUSR to the user id you
 # want VDR to run with. If VDRUSR is not set, VDR will run
-# as 'root', which is not necessarily advisable.
+# as user 'vdr'.
 #
 # Since this script loads the DVB driver, it must be started
 # as user 'root'.
@@ -18,11 +18,11 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: runvdr 1.14 2004/11/21 11:30:00 kls Exp $
+# $Id: runvdr 1.15 2005/12/31 16:04:53 kls Exp $
 
 DVBDIR="../DVB/driver"
 VDRPRG="./vdr"
-VDRCMD="$VDRPRG -w 60 $*"
+VDRCMD="$VDRPRG -u $VDRUSR -w 60 $*"
 
 LSMOD="`/sbin/lsmod | grep -w '^dvb' | wc -l`"
 KILL="/usr/bin/killall -q -TERM"
@@ -33,7 +33,7 @@
    fi
 
 while (true) do
-      su $VDRUSR -c "$VDRCMD"
+      $VDRCMD
       if test $? -eq 0 -o $? -eq 2; then exit; fi
       date
       echo "restarting VDR"
diff -ruN vdr-1.3.37/skinclassic.c vdr-1.3.38/skinclassic.c
--- vdr-1.3.37/skinclassic.c	2005-05-16 12:45:07.000000000 +0200
+++ vdr-1.3.38/skinclassic.c	2006-01-01 15:37:58.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinclassic.c 1.12 2005/05/16 10:45:07 kls Exp $
+ * $Id: skinclassic.c 1.13 2006/01/01 14:37:58 kls Exp $
  */
 
 #include "skinclassic.h"
@@ -378,7 +378,6 @@
   int x0, x1;
   int y0, y1, y2, y3;
   int lastCurrentWidth;
-  bool message;
 public:
   cSkinClassicDisplayReplay(bool ModeOnly);
   virtual ~cSkinClassicDisplayReplay();
@@ -397,7 +396,6 @@
   const cFont *font = cFont::GetFont(fontOsd);
   int lineHeight = font->Height();
   lastCurrentWidth = 0;
-  message = false;
   x0 = 0;
   x1 = Setup.OSDWidth;
   y0 = 0;
@@ -467,12 +465,9 @@
   if (Text) {
      osd->SaveRegion(x0, y2, x1 - 1, y3 - 1);
      osd->DrawText(x0, y2, Text, Theme.Color(clrMessageStatusFg + 2 * Type), Theme.Color(clrMessageStatusBg + 2 * Type), font, x1 - x0, y3 - y2, taCenter);
-     message = true;
      }
-  else {
+  else
      osd->RestoreRegion();
-     message = false;
-     }
 }
 
 void cSkinClassicDisplayReplay::Flush(void)
diff -ruN vdr-1.3.37/skins.c vdr-1.3.38/skins.c
--- vdr-1.3.37/skins.c	2005-11-27 16:52:25.000000000 +0100
+++ vdr-1.3.38/skins.c	2006-01-08 12:40:18.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skins.c 1.6 2005/11/27 15:52:25 kls Exp $
+ * $Id: skins.c 1.7 2006/01/08 11:40:18 kls Exp $
  */
 
 #include "skins.h"
@@ -323,7 +323,7 @@
          }
       else
          break;
-      } 
+      }
   queueMessageMutex.Unlock();
 }
 
diff -ruN vdr-1.3.37/skins.h vdr-1.3.38/skins.h
--- vdr-1.3.37/skins.h	2005-11-27 16:41:44.000000000 +0100
+++ vdr-1.3.38/skins.h	2006-01-08 12:40:21.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skins.h 1.9 2005/11/27 15:41:44 kls Exp $
+ * $Id: skins.h 1.10 2006/01/08 11:40:21 kls Exp $
  */
 
 #ifndef __SKINS_H
@@ -197,7 +197,7 @@
        ///< take care that it is erased from the display when a Current string
        ///< _with_ ".ff" is followed by one without it.
   virtual void SetTotal(const char *Total) = 0;
-       ///< Sets the total length of the recording, as a user readable 
+       ///< Sets the total length of the recording, as a user readable
        ///< string if the form "h:mm:ss".
   virtual void SetJump(const char *Jump) = 0;
        ///< Sets the prompt that allows the user to enter a jump point.
diff -ruN vdr-1.3.37/skinsttng.c vdr-1.3.38/skinsttng.c
--- vdr-1.3.37/skinsttng.c	2005-08-15 13:14:59.000000000 +0200
+++ vdr-1.3.38/skinsttng.c	2006-01-01 15:38:14.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinsttng.c 1.15 2005/08/15 11:14:59 kls Exp $
+ * $Id: skinsttng.c 1.16 2006/01/01 14:38:14 kls Exp $
  */
 
 // Star Trek: The Next Generation® is a registered trademark of Paramount Pictures
@@ -643,7 +643,6 @@
   int y0, y1, y2, y3, y4, y5, y6, y7;
   tColor frameColor;
   int lastCurrentWidth;
-  bool message;
 public:
   cSkinSTTNGDisplayReplay(bool ModeOnly);
   virtual ~cSkinSTTNGDisplayReplay();
@@ -666,7 +665,6 @@
   int lineHeight = font->Height();
   frameColor = Theme.Color(clrReplayFrame);
   lastCurrentWidth = 0;
-  message = false;
   cBitmap bm(play_xpm);
   x0 = 0;
   x1 = max(SymbolWidth, bm.Width());
@@ -772,12 +770,9 @@
      osd->SaveRegion(x2, y6, x4 - 1, y7 - 1);
      osd->DrawRectangle(x2, y6, x3 - 1, y7 - 1, Theme.Color(clrBackground));
      osd->DrawText(x3, y6, Text, Theme.Color(clrMessageStatusFg + 2 * Type), Theme.Color(clrMessageStatusBg + 2 * Type), font, x4 - x3, 0, taCenter);
-     message = true;
      }
-  else {
+  else
      osd->RestoreRegion();
-     message = false;
-     }
 }
 
 void cSkinSTTNGDisplayReplay::Flush(void)
diff -ruN vdr-1.3.37/status.c vdr-1.3.38/status.c
--- vdr-1.3.37/status.c	2005-01-09 12:51:04.000000000 +0100
+++ vdr-1.3.38/status.c	2005-12-31 16:10:10.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: status.c 1.7 2005/01/09 11:51:04 kls Exp $
+ * $Id: status.c 1.8 2005/12/31 15:10:10 kls Exp $
  */
 
 #include "status.h"
@@ -29,16 +29,16 @@
       sm->ChannelSwitch(Device, ChannelNumber);
 }
 
-void cStatus::MsgRecording(const cDevice *Device, const char *Name)
+void cStatus::MsgRecording(const cDevice *Device, const char *Name, const char *FileName, bool On)
 {
   for (cStatus *sm = statusMonitors.First(); sm; sm = statusMonitors.Next(sm))
-      sm->Recording(Device, Name);
+      sm->Recording(Device, Name, FileName, On);
 }
 
-void cStatus::MsgReplaying(const cControl *Control, const char *Name)
+void cStatus::MsgReplaying(const cControl *Control, const char *Name, const char *FileName, bool On)
 {
   for (cStatus *sm = statusMonitors.First(); sm; sm = statusMonitors.Next(sm))
-      sm->Replaying(Control, Name);
+      sm->Replaying(Control, Name, FileName, On);
 }
 
 void cStatus::MsgSetVolume(int Volume, bool Absolute)
diff -ruN vdr-1.3.37/status.h vdr-1.3.38/status.h
--- vdr-1.3.37/status.h	2005-01-09 12:50:21.000000000 +0100
+++ vdr-1.3.38/status.h	2005-12-31 16:15:25.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: status.h 1.8 2005/01/09 11:50:21 kls Exp $
+ * $Id: status.h 1.9 2005/12/31 15:15:25 kls Exp $
  */
 
 #ifndef __STATUS_H
@@ -24,15 +24,17 @@
                // Indicates a channel switch on the given DVB device.
                // If ChannelNumber is 0, this is before the channel is being switched,
                // otherwise ChannelNumber is the number of the channel that has been switched to.
-  virtual void Recording(const cDevice *Device, const char *Name) {}
-               // The given DVB device has started recording Name. Name is the name of the
-               // recording, without any directory path.
-               // If Name is NULL, the recording has ended. 
-  virtual void Replaying(const cControl *Control, const char *Name) {}
-               // The given player control has started replaying Name. Name is the name of the
-               // recording, without any directory path. In case of a player that can't provide
+  virtual void Recording(const cDevice *Device, const char *Name, const char *FileName, bool On) {}
+               // The given DVB device has started (On = true) or stopped (On = false) recording Name.
+               // Name is the name of the recording, without any directory path. The full file name
+               // of the recording is given in FileName, which may be NULL in case there is no
+               // actual file involved. If On is false, Name may be NULL.
+  virtual void Replaying(const cControl *Control, const char *Name, const char *FileName, bool On) {}
+               // The given player control has started (On = true) or stopped (On = false) replaying Name.
+               // Name is the name of the recording, without any directory path. In case of a player that can't provide
                // a name, Name can be a string that identifies the player type (like, e.g., "DVD").
-               // If Name is NULL, the replay has ended. 
+               // The full file name of the recording is given in FileName, which may be NULL in case there is no
+               // actual file involved. If On is false, Name may be NULL.
   virtual void SetVolume(int Volume, bool Absolute) {}
                // The volume has been set to the given value, either
                // absolutely or relative to the current volume.
@@ -70,8 +72,8 @@
   virtual ~cStatus();
   // These functions are called whenever the related status information changes:
   static void MsgChannelSwitch(const cDevice *Device, int ChannelNumber);
-  static void MsgRecording(const cDevice *Device, const char *Name);
-  static void MsgReplaying(const cControl *Control, const char *Name);
+  static void MsgRecording(const cDevice *Device, const char *Name, const char *FileName, bool On);
+  static void MsgReplaying(const cControl *Control, const char *Name, const char *FileName, bool On);
   static void MsgSetVolume(int Volume, bool Absolute);
   static void MsgSetAudioTrack(int Index, const char * const *Tracks);
   static void MsgSetAudioChannel(int AudioChannel);
